<?php
include_once(DIR_CATALOG.'/controller/module/iretail/iretailapi.php');

class ControllerModuleOCIRetailApi extends Controller {

  public function install() {

		$this->load->model('setting/setting');
		$this->model_setting_setting->editSetting('ociretailapi',['ociretailapi_statuses'=>[2]]);


    $this->load->model('extension/event');
    $this->model_extension_event->addEvent('ociretailapi', 'pre.order.history.add', 'module/iretail/ociretailapi/on_order_history_add_pre');
    $this->model_extension_event->addEvent('ociretailapi', 'post.order.history.add', 'module/iretail/ociretailapi/on_order_history_add_post');
  }
  
  public function uninstall() {
    $this->load->model('extension/event');
    $this->model_extension_event->deleteEvent('ociretailapi');
  }

	private $error = array();

	public function index() {

		$this->load->language('module/ociretailapi');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && isset($this->request->post['ir_clearlog'])) {
			IRetailAPI::clearLog();
			$this->session->data['success'] = $this->language->get('text_clearlog');
			$this->response->redirect($this->url->link('module/ociretailapi', 'token=' . $this->session->data['token'], 'SSL'));
		}

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('ociretailapi', $this->request->post);
			$this->session->data['success'] = $this->language->get('text_success');
			$this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');

		$data['entry_status'] = $this->language->get('entry_status');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];
			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}


		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_module'),
			'href' => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('module/ociretailapi', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['action'] = $this->url->link('module/ociretailapi', 'token=' . $this->session->data['token'], 'SSL');
		$data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');

		$pp=['ociretailapi_power','ociretailapi_mode','ociretailapi_log','ociretailapi_login','ociretailapi_apikey',
			'ociretailapi_printmode','ociretailapi_statuses','ociretailapi_notifymode','ociretailapi_emails'];

		foreach($pp as $p) {
			$data['entry_'.$p] = $this->language->get('entry_'.$p);
			if (isset($this->request->post[$p])) {
				$data[$p] = $this->request->post[$p];
			} else {
				$data[$p] = $this->config->get($p);
			}
		}
		$data['entry_ociretailapi_mode_0'] = $this->language->get('entry_ociretailapi_mode_0');
		$data['entry_ociretailapi_mode_1'] = $this->language->get('entry_ociretailapi_mode_1');

		$this->load->model('localisation/order_status');
		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();


		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('module/ociretailapi.tpl', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'module/ociretailapi')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}

	public function api()
	{
		if (!isset($this->request->get['order_id']) || !isset($this->request->get['action']))
			$this->response->redirect($this->url->link('sale/order', 'token=' . $this->session->data['token'], 'SSL'));

		$err=false;
		if (!$this->user->hasPermission('modify', 'module/ociretailapi')) {
			$this->error['warning'] = $this->language->get('error_permission');
			$err=true;
		}

		$this->load->language('module/ociretailapi');
		if (!$err) {
				$curl = curl_init();
				// Set SSL if required
				if (substr(HTTPS_CATALOG, 0, 5) == 'https') {
					curl_setopt($curl, CURLOPT_PORT, 443);
				}
				curl_setopt($curl, CURLOPT_HEADER, false);
				curl_setopt($curl, CURLINFO_HEADER_OUT, true);
				curl_setopt($curl, CURLOPT_USERAGENT, $this->request->server['HTTP_USER_AGENT']);
				curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
				curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
				curl_setopt($curl, CURLOPT_FORBID_REUSE, false);
				curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
				curl_setopt($curl, CURLOPT_URL, HTTPS_CATALOG . 'index.php?route=api/ociretailapi');
				curl_setopt($curl, CURLOPT_POST, true);
				curl_setopt($curl, CURLOPT_POSTFIELDS,
					http_build_query(['order_id'=>$this->request->get['order_id'],'refund'=>$this->request->get['action']=='refund']));
				$json = curl_exec($curl);
// var_dump(http_build_query(['order_id'=>$this->request->get['order_id'],'refund'=>$this->request->get['action']=='refund']));
				// var_dump($json);
				// die('api');

				if (!$json) {
					IRetailAPI::logAdd('Ошибка при запросе api. '.curl_error($curl));
					$this->session->data['error'] = $this->language->get('error_curl');
				} else {
					$response = json_decode($json, true);
					if (!$response)
					{
						IRetailAPI::logAdd('Некорректный ответ api. '.$json);
						$this->session->data['error'] = $this->language->get('error_curl');
					}
					else
					{
						//в этих случая логгирвоать не надо, т.к. все уже сделано на той стороне
						if ($response && $response['status'])
							$this->session->data['success']=$this->language->get('ok_curl');
						else
							$this->session->data['error'] = $this->language->get('error_curl');
					}
				}
				$this->response->redirect($this->url->link('sale/order/info', 'token=' . $this->session->data['token'].'&order_id='.$this->request->get['order_id'], 'SSL'));

			}
	}


}    
   